"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLogin = void 0;
const react_1 = require("react");
const generateState = () => 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    const r = (Math.random() * 16) | 0, v = c == 'x' ? r : (r & 0x3) | 0x8;
    return v.toString(16);
});
const useLogin = ({ baseUrl, clientId, authEndpoint, redirectUri, }) => {
    const getUri = (0, react_1.useCallback)(() => {
        const state = generateState();
        const urlParams = {
            client_id: clientId,
            redirect_uri: redirectUri,
            response_mode: 'fragment',
            response_type: 'code',
            scope: 'openid profile',
            state,
        };
        const connectionURI = new URL(`${baseUrl}${authEndpoint}`);
        for (const key of Object.keys(urlParams)) {
            connectionURI.searchParams.append(key, urlParams[key]);
        }
        return connectionURI;
    }, []);
    return { getUri };
};
exports.useLogin = useLogin;
