"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTokenExchange = void 0;
const react_1 = require("react");
const changeCodeForTokens_1 = require("../changeCodeForTokens");
const useTokenExchange = ({ baseUrl, clientId, tokenEndpoint, redirectUri, }) => {
    const exchange = (0, react_1.useCallback)((code) => __awaiter(void 0, void 0, void 0, function* () {
        const { data: tokens } = yield (0, changeCodeForTokens_1.changeCodeForTokens)({
            baseUrl,
            tokenEndpoint,
            clientId,
            redirectUri: redirectUri,
            code,
        });
        if (tokens) {
            return {
                authenticated: true,
                accessToken: tokens.access_token,
                refreshToken: tokens.refresh_token,
                idToken: tokens.id_token,
                accessExpiresIn: tokens.expires_in,
                refreshExpiresIn: tokens.refresh_expires_in,
                sessionState: tokens.session_state,
            };
        }
    }), []);
    return { exchange };
};
exports.useTokenExchange = useTokenExchange;
