"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renewAccessToken = void 0;
const isJSON_1 = require("@procyon/utils/isJSON");
const renewAccessToken = ({ baseUrl, clientId, tokenEndpoint, refreshToken, }) => __awaiter(void 0, void 0, void 0, function* () {
    const response = yield fetch(`${baseUrl}${tokenEndpoint}`, {
        method: 'post',
        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
        body: new URLSearchParams({
            client_id: clientId,
            grant_type: 'refresh_token',
            refresh_token: refreshToken,
        }),
    });
    const data = yield response
        .text()
        .then((text) => ((0, isJSON_1.isJSON)(text) ? JSON.parse(text) : text));
    if (!response.ok)
        throw response;
    return data;
});
exports.renewAccessToken = renewAccessToken;
